<template>
  <div
    class="g-dropdown-mask"
    :class="{ 'g-visible': activated }"
    @click.stop="activated = false"
    @contextmenu.prevent>
    <div class="g-dropdown g-appear-from-bottom" :class="{ 'g-visible': activated }">
      <slot />
    </div>
  </div>
</template>

<script>

export default {
  name: "GMobileMenuDropdown",
  emits: ["show", "hide"],
  data() {
    return {
      activated: false,
    };
  },
  watch: {
    activated(newVal) {
      if (newVal) {
        this.$emit("show");
      } else {
        this.$emit("hide");
      }
    },
  },
  methods: {
    show() {
      this.activated = true;
    },
  },
};

</script>

<style lang="scss" scoped>

  .g-dropdown {

    // Position
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    z-index: 10001;

    // Style
    background: white;

    border-radius: 4px;
    z-index: 10001;
    font-weight: normal;
    text-align: left;
    padding: 6px;
    display: flex;
    flex-direction: column;
    box-shadow: 0 1px 10px 0 rgba(0, 0, 0, 0.4);
    user-select: none;
    background: white;

    // Hide for animation
    overflow: hidden;
    transition: transform 0.05s ease-in-out;
    transform: scaleY(0);
    transform-origin: top;

    &.g-appear-from-bottom {
      transform-origin: bottom;
    }

    &.g-visible {
      transform: scaleY(1);
    }
  }

  .g-dropdown-mask {
    position: fixed;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    z-index: 10000;
    background: rgba(0, 0, 0, 0.2);
    display: none;

    &.g-visible {
      display: block;
    }
  }

</style>